

;												
; TSIC und ATmega8								
; Bernhard.Erfurt@gmx.de						
; 07/2011										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD-DATA								
; PB1 ==> LCD-DATA								
; PB2 ==> LCD-DATA								
; PB3 ==> LCD-DATA								
; PB4 ==> LCD-RS								
; PB5 ==> LCD-E									
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> SENSOR-DATA							
; PC1 ==> SENSOR-SPANNUNG						
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT					=1000000			; 1 MHz	
; SENSORBELEGUNG TSIC-206						
.equ SENSOR_EINGANG_PORT	= PINC		; SIGNAL-PORT		
.equ SENSOR_EINGANG_PIN		= 0			; SIGNAL-SPANNUNG	
.equ SENSOR_V_PORT			= PORTC		; SPANNUNG-PORT		
.equ SENSOR_V_PIN			= 1			; SPANNUNG-PIN		
.equ SENSOR_OFFSET			= 0			; OFFSETWERT		
; LEDS 											
.equ LED_D_GRUEN			= 5
.equ LED_D_GELB				= 6
.equ LED_D_ROT				= 7
; LCD											
.equ LCD_PORT				= PORTB
.equ LCD_D0					= 0
.equ LCD_D1					= 1
.equ LCD_D2					= 2
.equ LCD_D3					= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_PORT			= PORTB
.equ LCD_RS					= 4
; LCD_ENABLE									
.equ LCD_E_PORT				= PORTB
.equ LCD_E					= 5


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_WERT					=0x0060+8			; TESTWERT					

.equ adr_STROBE					=0x0060+9			; SENSOR-STROBE				

.equ adr_TEMPERATURDATEN_L		=0x0060+10			; SENSOR-DATENWERT			
.equ adr_TEMPERATURDATEN_H		=0x0060+11

.equ adr_TEMPERATUR_L			=0x0060+20			; SENSOR-Temperaturwert		
.equ adr_TEMPERATUR_H			=0x0060+21

.equ adr_BIT_A					=0x0060+101			; Darstellung der Bitwerte	
.equ adr_BIT_B					=0x0060+102
.equ adr_BIT_C					=0x0060+103
.equ adr_BIT_D					=0x0060+104
.equ adr_BIT_E					=0x0060+105
.equ adr_BIT_F					=0x0060+106
.equ adr_BIT_G					=0x0060+107
.equ adr_BIT_H					=0x0060+108
.equ adr_BIT_I					=0x0060+109

.equ adr_BIT_J					=0x0060+111
.equ adr_BIT_K					=0x0060+112
.equ adr_BIT_L					=0x0060+113
.equ adr_BIT_M					=0x0060+114
.equ adr_BIT_N					=0x0060+115
.equ adr_BIT_O					=0x0060+116
.equ adr_BIT_P					=0x0060+117
.equ adr_BIT_Q					=0x0060+118
.equ adr_BIT_R					=0x0060+119
; REGISTER										
.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	

; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b11111111	; DISPLAY	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000010	; SENSOR
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
	ldi temp, 0b00000000	; 
; PORT D initialisieren								
	ldi temp, 0b11100000	; LEDs
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b11100000	;
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
; ##############################################################################
; ##############################################################################
; ##############################################################################

	; LCD_INITIALISIERUNG	
	rcall LCD_INITIALISIERUNG
	; ANZEIGE_BEGRUESSUNG	
	rcall ANZEIGE_BEGRUESSUNG
	; LED-TEST				
	rcall LED_TEST
	; Interrupts freigeben	
	sei	

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	rcall SENSOR_TSIC_ABFRAGEN
	rcall ANZEIGE
	rcall PROGRAMM_CHECK
	rcall wait_100ms


rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "THERMO_LCD.asm"
.include "THERMO_SONSTIGES.asm"
.include "THERMO_TSIC206.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "TSIC 206",0
TEXT_BEGRUESSUNG_2:
.db "07/2011",0


